﻿USE [QLSV_NHOM_LAP4]
GO
--Nhân Viên
alter PROC SP_INS_PUBLIC_ENCRYPT_NHANVIEN 
@MANV VARCHAR(20), @HOTEN NVARCHAR(100),
@EMAIL VARCHAR(50), @LUONG VARBINARY(MAX),
@TENDN VARCHAR(50), @MATKHAU VARBINARY(MAX),
@PUBKEY varchar(max),@PRIKEY varchar(max)
as 
BEGIN
	INSERT INTO  NHANVIEN
	VALUES (@MANV, @HOTEN,@EMAIL,@LUONG,@TENDN,@MATKHAU,convert(xml,@PUBKEY),convert(xml,@PRIKEY))
END
GO

CREATE PROC SP_SEL_PUBLIC_ENCRYPT_NHANVIEN
@TENDN VARCHAR(50),@MATKHAU VARCHAR(MAX)
AS
BEGIN
	SELECT MANV, HOTEN, EMAIL,CONVERT(VARCHAR(MAX),LUONG) FROM NHANVIEN 
END
GO

CREATE PROC SP_CHECK_NHANVIEN_PASSWORD
@TENDN VARCHAR(20),@MATKHAU VARBINARY(MAX)
AS
BEGIN
	SELECT MATKHAU,MANV FROM NHANVIEN WHERE TENDN = @TENDN AND MATKHAU = @MATKHAU;
END
GO

CREATE PROC SP_SEL_NAME_NHANVIEN
AS
BEGIN
	SELECT HOTEN FROM NHANVIEN
END
GO

CREATE PROC SP_CHECK_NVCHAMDIEM
@MALOP VARCHAR(20)
AS
BEGIN
	SELECT MANV FROM LOP WHERE MALOP=@MALOP;
END
GO 

ALTER PROC SP_SEL_PUB_NHANVIEN
@MANV VARCHAR(20)
AS
BEGIN
	SELECT cast(PUBKEY as nvarchar(max)) FROM NHANVIEN WHERE MANV =@MANV;
END
GO
exec SP_SEL_PUB_NHANVIEN 'NV06'
ALTER PROC SP_SEL_PRI_NHANVIEN
@MANV VARCHAR(20)
AS
BEGIN
	SELECT cast(PRIKEY as nvarchar(max)) FROM NHANVIEN WHERE MANV =@MANV;
END
GO
--Sinh Viên
CREATE PROC SP_CHECK_SINHVIEN
@TENDN VARCHAR(20),@MATKHAU VARBINARY(MAX)
AS
BEGIN
	SELECT MATKHAU,MASV FROM SINHVIEN WHERE TENDN = @TENDN AND MATKHAU = @MATKHAU;
END
go

create proc SP_INS_SINHVIEN
@MASV NVARCHAR(50), @HOTEN NVARCHAR(100), @NGAYSINH DATETIME, @DIACHI NVARCHAR(100), @MALOP VARCHAR(50),@TENDN VARCHAR(50),@MATKHAU VARCHAR(50)
AS
BEGIN
	DECLARE @MKMAHOA VARBINARY(MAX) = HASHBYTES('MD5',@MATKHAU)
	INSERT INTO SINHVIEN
	VALUES(@MASV,@HOTEN,@NGAYSINH,@DIACHI,@MALOP,@TENDN,@MKMAHOA)
END
go

CREATE PROC SP_SEL_SINHVIEN
@MALOP VARCHAR(20)
AS
BEGIN
	SELECT MASV,HOTEN,NGAYSINH,DIACHI,TENDN FROM SINHVIEN WHERE SINHVIEN.MALOP =@MALOP;
END
GO

--Lớp
CREATE PROC SP_INS_LOP
@MALOP VARCHAR(20), @TENLOP NVARCHAR(100), @HOTEN NVARCHAR(100)
AS
BEGIN
	DECLARE @MANV VARCHAR(20) = (SELECT MANV FROM NHANVIEN WHERE HOTEN=@HOTEN);
	INSERT INTO LOP
	VALUES(@MALOP,@TENLOP,@MANV)
END
GO
EXEC SP_INS_LOP 'KH03','KHOA HỌC MÁY TÍNH','NGUYEN VAN B'
EXEC SP_INS_LOP 'KH04','MẠNG MÁY TÍNH','TRAN TIEN QUAN'
GO

CREATE PROC SP_SEL_LOP
AS
BEGIN
	SELECT MALOP, TENLOP ,HOTEN FROM LOP, NHANVIEN WHERE LOP.MANV = NHANVIEN.MANV;
END
GO

CREATE PROC SP_CHECK_LOP
@MALOP VARCHAR(20)
AS
BEGIN
	SELECT MALOP FROM LOP WHERE MALOP=@MALOP
END
GO
 
CREATE PROC SP_UPD_LOP
@MALOP VARCHAR(20), @TENLOP NVARCHAR(100), @HOTEN NVARCHAR(100)
AS
BEGIN
	DECLARE @MANV VARCHAR(20) = (SELECT MANV FROM NHANVIEN WHERE HOTEN=@HOTEN);
	UPDATE LOP
	SET MANV=@MANV ,TENLOP=@TENLOP WHERE MALOP=@MALOP
END 
GO

CREATE PROC SP_DEL_LOP
@MALOP VARCHAR(20)
AS
BEGIN 
	DELETE FROM LOP WHERE MALOP = @MALOP;
END
GO

CREATE PROC SP_SEL_NAME_LOP
AS
BEGIN
	SELECT TENLOP FROM LOP
END
GO

CREATE PROC SP_CNT_SV_LOP
@MALOP VARCHAR(50)
AS
BEGIN
	SELECT COUNT(MASV) AS SOLUONG FROM SINHVIEN,LOP WHERE LOP.MALOP =@MALOP AND SINHVIEN.MALOP = LOP.MALOP 
END
go

--Điểm
Create PROC SP_SEL_DIEM
@MALOP VARCHAR(20)
AS
BEGIN
	DECLARE @MANV VARCHAR(20) = (SELECT MANV FROM LOP WHERE MALOP=@MALOP );
	SELECT SINHVIEN.MASV,HOTEN, 
	DIEMTHI FROM BANGDIEM,SINHVIEN WHERE BANGDIEM.MASV =SINHVIEN.MASV and BANGDIEM.MALOP = @MALOP
END
GO

ALTER PROC SP_INS_DIEM
@MASV VARCHAR(20), @MALOP NVARCHAR(100), @DIEM VARBINARY(MAX) 
AS 
BEGIN 
	INSERT INTO BANGDIEM 
	VALUES(@MASV,@MALOP,@DIEM)
END
GO

alTER PROC SP_CHECK_INS_DIEM
@MASV VARCHAR(20), @MALOP VARCHAR(20)
AS
BEGIN
	SELECT SINHVIEN.MASV FROM SINHVIEN WHERE MASV=@MASV AND MALOP= @MALOP
END
GO

CREATE PROC SP_CHECK_DIEM
@MASV VARCHAR(20)
AS
BEGIN
	SELECT MASV FROM BANGDIEM WHERE MASV=@MASV;
END
GO

CREATE PROC SP_UPD_DIEM
@MASV VARCHAR(20), @MALOP NVARCHAR(100), @DIEM VARBINARY(MAX) 
AS
BEGIN
	UPDATE BANGDIEM SET MALOP=@MALOP, DIEMTHI = @DIEM WHERE MASV = @MASV
END
GO